MODULE:=sopalin

MY_SRC:= bordi.c		\
	 sopalin_thread.c


MY_SRC_MULT_ARCH :=	sopalin_init.c		\
			sopalin_option.c	\
			pastix.c		\
			ooc.c			\
			debug_dump.c		\
			csc_intern_io.c		\
			csc_intern_compute.c	\
			csc_intern_build.c	\
			csc_intern_solve.c	\
			csc_intern_updown.c	\
			tools.c			\
			coefinit.c		\
			sopalin_init.c		\
			debug_dump.c		\
			csc_intern_io.c		\
			csc_intern_compute.c	\
			csc_intern_build.c	\
			csc_intern_solve.c	\
			csc_intern_updown.c	\
			ooc.c			\
			sopalin3d.c		\
			pastix.c		\
			pastix_fortran.c	\
			cscd_utils.c		\
			csc_utils.c		\
			cscd_utils_fortran.c


ifeq (1, $(words $(findstring -DWITH_STARPU, ${CCOPT})))
ifeq (0, $(words $(findstring -DFORCE_NO_CUDA, ${CCOPT})))
MY_SRC_MULT_ARCH:= $(MY_SRC_MULT_ARCH) sparse_gemm_blocktab.cu
endif
endif

MY_SRC_FACT_TYPE :=	sopalin3d.c		\
			starpu_submit_tasks.c

MY_SRC_MURGE 		:= murge_fortran.c murge.c
MY_SRC_MURGE_MULT_ARCH  :=


OJTDIR:=$(MODULE)/obj/$(HOSTARCH)
DEPDIR:=$(MODULE)/dep
SRCDIR:=$(MODULE)/src

MY_SRC 		 := $(patsubst %,$(SRCDIR)/%,$(MY_SRC))
MY_SRC_MULT_ARCH := $(patsubst %,$(SRCDIR)/%,$(MY_SRC_MULT_ARCH))
MY_SRC_FACT_TYPE := $(patsubst %,$(SRCDIR)/%,$(MY_SRC_FACT_TYPE))

MY_SRC_MULT_ARCH := $(MY_SRC_MULT_ARCH) 		\
	$(MY_SRC_FACT_TYPE)				\
	$(patsubst %.c,%_ge.c,$(MY_SRC_FACT_TYPE))	\
	$(patsubst %.c,%_sy.c,$(MY_SRC_FACT_TYPE))      \
	$(patsubst %.c,%_he.c,$(MY_SRC_FACT_TYPE))

MY_OBJ :=  $(patsubst %.c,%.o,$(filter %.c,$(MY_SRC))) 			\
	$(patsubst %.cu,%.o,$(filter %.cu,$(MY_SRC)))			\
	$(patsubst %.c,%.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) 		\
	$(patsubst %.cu,%.o,$(filter %.cu,$(MY_SRC_MULT_ARCH)))		\
	$(patsubst %.c,%_s.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) 	\
	$(patsubst %.cu,%_s.o,$(filter %.cu,$(MY_SRC_MULT_ARCH)))	\
	$(patsubst %.c,%_d.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) 	\
	$(patsubst %.cu,%_d.o,$(filter %.cu,$(MY_SRC_MULT_ARCH)))	\
	$(patsubst %.c,%_c.o,$(filter %.c,$(MY_SRC_MULT_ARCH))) 	\
	$(patsubst %.cu,%_c.o,$(filter %.cu,$(MY_SRC_MULT_ARCH)))	\
	$(patsubst %.c,%_z.o,$(filter %.c,$(MY_SRC_MULT_ARCH)))		\
	$(patsubst %.cu,%_z.o,$(filter %.cu,$(MY_SRC_MULT_ARCH)))

ifeq (2, $(words $(findstring -DTYPE_COMPLEX, ${CCOPT}) $(findstring -DPREC_DOUBLE, ${CCOPT})))
MY_OBJ := $(filter-out %/sparse_gemm_blocktab.o, ${MY_OBJ})
endif
MY_OBJ := $(filter-out %/sparse_gemm_blocktab_z.o, ${MY_OBJ})


MY_OBJ := $(patsubst $(SRCDIR)/%,$(OJTDIR)/%,$(MY_OBJ))

OBJ_LIB := $(OBJ_LIB) $(MY_OBJ)
DEP_LIB := $(DEP_LIB) $(patsubst $(OJTDIR)/%.o,$(DEPDIR)/%.d,$(MY_OBJ))

MY_SRC_MURGE 		:= $(patsubst %,$(SRCDIR)/%,$(MY_SRC_MURGE))
MY_SRC_MURGE_MULT_ARCH  := $(patsubst %,$(SRCDIR)/%,$(MY_SRC_MURGE_MULT_ARCH))

MY_OBJ := $(patsubst %.c,%.o,$(filter %.c,$(MY_SRC_MURGE))) 		\
	$(patsubst %.c,%.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))	\
	$(patsubst %.c,%_s.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))	\
	$(patsubst %.c,%_d.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))	\
	$(patsubst %.c,%_c.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))	\
	$(patsubst %.c,%_z.o,$(filter %.c,$(MY_SRC_MURGE_MULT_ARCH)))
MY_OBJ := $(patsubst $(SRCDIR)/%,$(OJTDIR)/%,$(MY_OBJ))

OBJ_MURGE := $(OBJ_MURGE) $(MY_OBJ)
DEP_MURGE := $(DEP_MURGE) $(patsubst $(OJTDIR)/%.o,$(DEPDIR)/%.d,$(MY_OBJ))

include all_mp_rules.mk

ifeq (1, $(words $(findstring -DWITH_STARPU, ${CCOPT})))
ifeq (0, $(words $(findstring -DFORCE_NO_CUDA, ${CCOPT})))
NVCCOPT := ${NVCCOPT} $(patsubst -g3, -g, ${CCOPT})
ifeq (1, $(words $(findstring debug, ${MAKECMDGOALS})))
NVCCOPT := ${NVCCOPT} -G
endif
$(OJTDIR)/%$(OBJ) : $(SRCDIR)/%.cu config.in
	nvcc ${NVCCOPT} $(CCINC) $(CCTYPESFLT) -DNO_TYPE_PREFIX -c $< -o $@
$(OJTDIR)/%_s$(OBJ) : $(SRCDIR)/%.cu config.in
	nvcc ${NVCCOPT} $(CCINC)  -c $< -o $@
$(OJTDIR)/%_d$(OBJ) : $(SRCDIR)/%.cu config.in
	nvcc ${NVCCOPT} $(CCINC) -DFORCE_DOUBLE -DPREC_DOUBLE -c $< -o $@
$(OJTDIR)/%_c$(OBJ) : $(SRCDIR)/%.cu config.in
	nvcc ${NVCCOPT} $(CCINC) -DFORCE_COMPLEX -DTYPE_COMPLEX -c $< -o $@
$(OJTDIR)/%_z$(OBJ) : $(SRCDIR)/%.cu config.in
	nvcc ${NVCCOPT} $(CCINC) -DFORCE_DOUBLE -DPREC_DOUBLE -DFORCE_COMPLEX -DTYPE_COMPLEX -c $< -o $@
endif
endif

$(OJTDIR)/%$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DCHOL_SOPALIN $(CCTYPESFLT) -DNO_TYPE_PREFIX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN $(CCTYPESFLT) -DNO_TYPE_PREFIX
$(OJTDIR)/%_s$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DCHOL_SOPALIN;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN
$(OJTDIR)/%_d$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC)  -DCHOL_SOPALIN -DFORCE_DOUBLE;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN -DFORCE_DOUBLE
$(OJTDIR)/%_c$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DCHOL_SOPALIN -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN -DFORCE_COMPLEX
$(OJTDIR)/%_z$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DCHOL_SOPALIN -DFORCE_DOUBLE -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DCHOL_SOPALIN -DFORCE_DOUBLE -DFORCE_COMPLEX

$(OJTDIR)/%_ge$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU $(CCTYPESFLT) -DNO_TYPE_PREFIX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DSOPALIN_LU $(CCTYPESFLT) -DNO_TYPE_PREFIX
$(OJTDIR)/%_ge_s$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DSOPALIN_LU
$(OJTDIR)/%_ge_d$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU -DFORCE_DOUBLE;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DSOPALIN_LU -DFORCE_DOUBLE
$(OJTDIR)/%_ge_c$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@  -DSOPALIN_LU -DFORCE_COMPLEX
$(OJTDIR)/%_ge_z$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DSOPALIN_LU -DFORCE_DOUBLE -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DSOPALIN_LU -DFORCE_DOUBLE -DFORCE_COMPLEX

$(OJTDIR)/%_sy$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) $(CCTYPESFLT)  -DNO_TYPE_PREFIX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@  $(CCTYPESFLT)  -DNO_TYPE_PREFIX
$(OJTDIR)/%_sy_s$(OBJ):	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC);
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@
$(OJTDIR)/%_sy_d$(OBJ):	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DFORCE_DOUBLE;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DFORCE_DOUBLE
$(OJTDIR)/%_sy_c$(OBJ):	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DFORCE_COMPLEX
$(OJTDIR)/%_sy_z$(OBJ):	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DFORCE_DOUBLE -DFORCE_COMPLEX;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DFORCE_DOUBLE -DFORCE_COMPLEX

$(OJTDIR)/%_he$(OBJ)	:	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) $(CCTYPESFLT)  -DNO_TYPE_PREFIX -DHERMITIAN;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@  $(CCTYPESFLT)  -DNO_TYPE_PREFIX  -DHERMITIAN
$(OJTDIR)/%_he_s$(OBJ):	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC)  -DHERMITIAN;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@  -DHERMITIAN
$(OJTDIR)/%_he_d$(OBJ):	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DFORCE_DOUBLE  -DHERMITIAN;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DFORCE_DOUBLE  -DHERMITIAN
$(OJTDIR)/%_he_c$(OBJ):	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DFORCE_COMPLEX  -DHERMITIAN;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DFORCE_COMPLEX  -DHERMITIAN
$(OJTDIR)/%_he_z$(OBJ):	$(SRCDIR)/%.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) -DFORCE_DOUBLE -DFORCE_COMPLEX  -DHERMITIAN;
	$(MPCCPRG) $(CCOPT) $(CCINC) -c $< -o $@ -DFORCE_DOUBLE -DFORCE_COMPLEX  -DHERMITIAN

MURGE_FORTRAN_INC = common_pastix.h

$(SRCDIR)/murge_fortran.c	:	murge/include/murge.h			\
					$(SRCDIR)/murge_pastix_fortran.c	\
					murge/scripts/geninterface.pl
	-$(RM) $@
	for f in $(MURGE_FORTRAN_INC) ; do			\
		echo "#include \""$${f}"\"" >> $@;		\
	done
	echo "#ifdef FORCE_NOMPI"   >> $@
	echo "#include \"nompi.h\"" >> $@
	echo "#else		  " >> $@
	echo "#include <mpi.h>	  " >> $@
	echo "#endif              " >> $@
	murge/scripts/geninterface.pl -f $< >> $@
	cat sopalin/src/murge_pastix_fortran.c  >> $@

$(OJTDIR)/murge_fortran$(OBJ)	:	$(SRCDIR)/murge_fortran.c config.in
	$(MAKEDEPEND) $(CCOPT) $(CCINC) $(CCTYPESFLT) -DNO_TYPE_PREFIX ;
	$(MPCCPRG) $(CCOPT) $(CCINC) $(CCTYPESFLT) -DNO_TYPE_PREFIX -c $< -o $@
