/* Copyright 2008 BORDEAUX I UNIVERSITY & INRIA 
**
** This file is part of the PaStiX parallel sparse matrix package.
**
** This software is governed by the CeCILL-C license under French law
** and abiding by the rules of distribution of free software. You can
** use, modify and/or redistribute the software under the terms of the
** CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
** URL: "http://www.cecill.info".
** 
** As a counterpart to the access to the source code and rights to copy,
** modify and redistribute granted by the license, users are provided
** only with a limited warranty and the software's author, the holder of
** the economic rights, and the successive licensors have only limited
** liability.
** 
** In this respect, the user's attention is drawn to the risks associated
** with loading, using, modifying and/or developing or reproducing the
** software by the user in light of its specific status of free software,
** that may mean that it is complicated to manipulate, and that also
** therefore means that it is reserved for developers and experienced
** professionals having in-depth computer knowledge. Users are therefore
** encouraged to load and test the software's suitability as regards
** their requirements in conditions enabling the security of their
** systems and/or data to be ensured and, more generally, to use and
** operate it in the same conditions as regards security.
** 
** The fact that you are presently reading this means that you have had
** knowledge of the CeCILL-C license and that you accept its terms.
*/
void API_CALL(updo_up_WaitCtrb_storage)  (Sopalin_Data_t *sopalin_data,
                                          INT, void *, INT, INT);

#ifdef PASTIX_UPDO_ISEND
void API_CALL(test_all_downsend)(Sopalin_Data_t *sopalin_data, INT me, int tag);
void API_CALL(test_all_upsend)  (Sopalin_Data_t *sopalin_data, INT me, int tag);
void API_CALL(wait_all_downsend)(Sopalin_Data_t *sopalin_data, INT me);
void API_CALL(wait_all_upsend)  (Sopalin_Data_t *sopalin_data, INT me);
#endif

/* Réceptions des contributions pour la remontée */
#ifndef FORCE_NOMPI

/* /\* Thread de communication *\/ */
/* void* API_CALL(updo_thread_comm)(void * arg){ return NULL; } */

int  API_CALL(probe_updown)(MPI_Comm, INT);

#ifndef STORAGE
void API_CALL(updo_up_WaitCtrb_nostorage)(Sopalin_Data_t *sopalin_data,
                                          INT, void *, INT, INT);
#endif

/* Réceptions des comms MPI */
static inline
void API_CALL(updo_down_send)(Sopalin_Data_t *sopalin_data, INT, INT, INT);
void API_CALL(updo_down_recv)(Sopalin_Data_t *sopalin_data, void *,
                              MPI_Status, INT);
static inline
void API_CALL(updo_up_send)  (Sopalin_Data_t *sopalin_data, INT, INT, INT);
void API_CALL(updo_up_recv)  (Sopalin_Data_t *sopalin_data, void *,
                              MPI_Status, INT);

#ifdef THREAD_COMM
/* Thread de communication */
void* API_CALL(updo_thread_comm)(void *);
#endif

#else /* FORCE_NOMPI */

void API_CALL(updo_up_WaitCtrb_nostorage)(Sopalin_Data_t *sopalin_data,
                                          INT buf_size, void *buf,
                                          INT me, INT i){}
int  API_CALL(probe_updown)(MPI_Comm comm, INT tag){ return 0; }

#endif
